/*
 * Copyright (C) 2003-2006 Funambol
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

//
// @author Marco Magistrali
// @version $Id: SyncMLDMCon.cpp,v 1.0 2004/04/27 11:21:00 magi Exp $
//
#include "spdm/win32/SyncMLDMCon.h"


SyncMLDMCon::SyncMLDMCon(ManagementNode* node) {
    LOG.debug(TEXT("in SyncMLDMCon"));
    readFromDM(node);    
}



BOOL SyncMLDMCon::readFromDM(ManagementNode* node) {
    
    BOOL ret = FALSE;

    if (node == NULL) {
        lastErrorCode = ERR_INVALID_CONTEXT;
        wsprintf(lastErrorMsg, TEXT("SyncMLDMCon node configuration NULL"));
        LOG.error(lastErrorMsg);
        goto finally;
    }
    wchar_t buf[INT_VALUESIZE]; // big enough for everything

    node->getPropertyValue(PROPERTY_CON_BEARER,     buf, INT_VALUESIZE, FALSE );
    setBearer(buf);
    //if (err != 0) goto finally;

    node->getPropertyValue(PROPERTY_CON_ADDRTYPE,   buf, INT_VALUESIZE, FALSE );
    setAddrType(buf);
    // if (err != 0) goto finally;

    node->getPropertyValue(PROPERTY_CON_ADDR,       buf, INT_VALUESIZE, FALSE );
    setAddr(buf);
    //if (err != 0) goto finally;

    if (lastErrorCode != 0) {        
        wsprintf(lastErrorMsg, TEXT("SyncMLDMCon configuration not found"));
        LOG.error(lastErrorMsg);
        goto finally;
    }

    ret = TRUE;
    
finally:
    return ret;

}


wchar_t* SyncMLDMCon::getBearer() {
    return bearer;
}

void SyncMLDMCon::setBearer(wchar_t* p) {
    wcsncpy(bearer, p, DIM_CON_BEARER);
    bearer[DIM_CON_BEARER -1] = 0;
    
}

wchar_t* SyncMLDMCon::getAddrType() {
    return addrType;
}

void SyncMLDMCon::setAddrType(wchar_t* p) {
    wcsncpy(addrType, p, DIM_CON_ADDRTYPE);
    addrType[DIM_CON_ADDRTYPE -1] = 0;
    
}
wchar_t* SyncMLDMCon::getAddr() {
    return addr;
}

void SyncMLDMCon::setAddr(wchar_t* p) {
    wcsncpy(addr, p, DIM_CON_ADDR);
    addr[DIM_CON_ADDR -1] = 0;
    
}