/*
 * Copyright (C) 2003-2006 Funambol
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef INCL_DM_DEVDETAIL
    #define INCL_DM_DEVDETAIL

    #include "http/common/Constants.h"
    #include "spds/common/Constants.h"    
    #include "spdm/common/Constants.h"
    #include "spdm/common/ManagementNode.h"
    #include "spdm/win32/DevDetailURI.h"

    #define PROPERTY_DEVTYP    TEXT("DevTyp")
    #define PROPERTY_OEM       TEXT("OEM"   )
    #define PROPERTY_FWV       TEXT("FwV"   )
    #define PROPERTY_SWV       TEXT("SwV"   )
    #define PROPERTY_HWV       TEXT("HwV"   )
    #define PROPERTY_LRGOBJ    TEXT("LrgObj")
    
    #define INT_VALUESIZE         512
    
    class __declspec(dllexport) DevDetail {

    private:

        wchar_t devTyp   [DIM_DEVTYP];
        wchar_t OEM      [DIM_OEM   ];
        wchar_t fwV      [DIM_FWV   ];
        wchar_t swV      [DIM_SWV   ];
        wchar_t hwV      [DIM_HWV   ];
        wchar_t lrgObj   [DIM_LRGOBJ];
        

    public:
        DevDetail();
        DevDetail(ManagementNode* node);
        ~DevDetail();

        wchar_t* getDevTyp();
        void setDevTyp(wchar_t* devTyp);

        wchar_t* getOEM();
        void setOEM(wchar_t* OEM);

        wchar_t* getFwV();
        void setFwV(wchar_t* fwV);

        wchar_t* getSwV();
        void setSwV(wchar_t* swV);

        wchar_t* getHwV();
        void setHwV(wchar_t* hwV);

        wchar_t* getLrgObj();
        void setLrgObj(wchar_t* lrgObj);

        DevDetailURI *devDetailUri;
     
        /*
         * Reads the configuration from the device manager
         */
        BOOL readFromDM(ManagementNode* node);

        /*
         * Stores the changed information into the device manager.
         * It returns TRUE if the operation was successfull, FALSE otherwise.
         *
         * NOTE: this methods must be mainly developed. For now it stores the sources
         *       last timestamp only. Is TBD to trace which fields are changed and
         *       persists them in the DM as well.
         */
        //BOOL saveToDM();

    };
#endif